package pack;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.border.Border;

public class Interface extends JFrame{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	JPanel[][] griglia=new JPanel[5][6]; //griglia
	JPanel elencoNumeri=new JPanel(); //tutti i numeri da 0 a 9
	JPanel descrizione=new JPanel(); //pannello descrizione
	JButton[] plus=new JButton[7]; //tasti +
	JButton[] num=new JButton[10]; //tasti gialli dei numeri
	JButton calcola,reset,chiudiDescr; // tasti operazionali
	JLabel[] numeroLabel=new JLabel[10]; //contenitori delle immagini di tutti i numeri da 0 a 9
	JLabel[] label=new JLabel[7]; //contenitori delle immagini degli operandi
	JLabel[] didascalia=new JLabel[7]; //n*X    X=1,10,100,1000
	JLabel[] risultato=new JLabel[7]; //contenitori delle immagini del risultato
	JLabel[] up=new JLabel[12]; //contenitore del triangolo superiore
	JLabel[] down=new JLabel[12]; //contenitore del triangolo inferiore
	JLabel[] slash=new JLabel[12]; //contenitore dell'immagine di divisione diagonale
	JLabel[] risUnita=new JLabel[7]; ////contenitori delle immagini delle unità del risultato
	JLabel logo; //contenitore del logo
	JLabel descrizioneText; //contiene la descrizione del funzionamento del programma
	Icon[] numero=new Icon[10]; //icone dei 10 numeri
	Icon icon=(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/Slash.png")).getImage().getScaledInstance(130, 100, 0))); //immagine di divisione diagonale
	Icon logoo=(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/maya.jpg")).getImage().getScaledInstance(130, 130, 0))); //logo
	static int[] valueArray=new int[7]; //contiene il vero valore degli operandi
	Matrice matrix; //l'oggetto Matrice che verrà popolato con i dati inseriti dall' utente
	Border border=BorderFactory.createLineBorder(Color.BLACK, 2);//formattazione del bordo della casella
	Font f=new Font("verdana", 0, 18); //font di default
	Font italic=new Font("verdana", 2, 14); //font italic
	int larghezza=(int) Toolkit.getDefaultToolkit().getScreenSize().getWidth(); //ottiene la risoluzione dell'asse X dello schermo in pixel
	
	public Interface()
	{
		int x,y=50,k=0,n=10,l=0,s=0,xSpace=160,ySpace=110; //varie variabili usate per definire margini di elementi e contatori di array
		setLayout(null); //layout del frame
		this.getContentPane().setBackground(Color.WHITE); //imposta il colore di sfondo (Bianco)
		
		//logo maya
		logo=new JLabel(logoo);
		logo.setBounds(15, 15, 130, 130);
		add(logo);
		
		//pannello che contiene la descrizione
		descrizione.setLayout(null);
		descrizione.setBounds(larghezza-((int)(larghezza/2.5)), 20, 320, 580);
		descrizione.setBackground(Color.WHITE);
		add(descrizione);
		
		//label che contiene la descrizione
		descrizioneText=new JLabel("<html><b>MOLTIPLICAZIONE SU ABACO MAYA</b><br><br>Inserisci sull' abaco Maya i 2 valori da moltiplicare.<br>Puoi moltiplicare un valore intero di max 4 cifre (max 9999) per un altro valore intero di max 3 cifre(max 999).<br><br>Gli operandi sono rispettivamente disposti sul lato orizzontale in alto e su quello verticale a destra (la significatività delle posizioni cresce progressivamente verso l'alto e verso sinistra).<br><br>Clicca sul tasto '+' per inserire la cifra nella posizione corretta.<br>Dopo aver inserito tutte le cifre procedi con il calcolo.<br><br><br><br><br>Per una descrizione più dettagliata è possibile consultare la 'User guide'<br><br><br><br><br></html>");
		descrizioneText.setBounds(10, 0, 300, 600);
		descrizioneText.setFont(italic);
		descrizione.add(descrizioneText);
		
		for(int i=0;i<griglia.length;i++)
		{
			x=0;
			for(int j=0;j<griglia[0].length;j++)
			{
				//inserisce ogni casella della griglia al posto giusto
				griglia[i][j]=new JPanel();
				griglia[i][j].setLayout(null); //layout della casella
				
				//ci troviamo nei bordi della matrice
				if(i==0 || i==griglia.length-1 || j==0 || j==griglia[0].length-1)
				{
					//siamo negli angoli o spigoli
					if((i==0 && j==0) || (i==0 && j==griglia[0].length-1) || (i==griglia.length-1 && j==0) || (i==griglia.length-1 && j==griglia[0].length-1))
					{
						//non disegna niente
					}
					//ci troviamo nei bordi ma non negli angoli. Pisizioniamo i bottoni
					else if((i==0 && j!=0 && j!=griglia[0].length-1) || (j==griglia[0].length-1 && i!=0 && i!=griglia.length-1))
					{
							//inserisce i bottoni "+" per l'inserimento delle cifre
							plus[k]=new JButton("+");
							plus[k].setActionCommand(""+k);
							plus[k].setBounds(40, 30, 70, 40);
							plus[k].setBackground(Color.GREEN);
							plus[k].setFont(f);
							griglia[i][j].add(plus[k]);
							
							//controllo per far "scomparire" momentaneamente alcuni pulsanti in caso di risoluzione <=1000 x YYY (es. 800x600)
							if((k==2 || k==3) && larghezza<=1000)
							{
								plus[k].setVisible(false);
							}

							label[k]=new JLabel();
							label[k].setBounds(20, 5, 140, 90);
							label[k].setVisible(false);
							//label.setBorder(border);
							griglia[i][j].add(label[k]);
							
							k++;
					}
					//ci troviamo nei bordi, non negli angoli e non dove vanno i bottoni, cioè nella prima colonna e ultima riga della matrice che dovranno contenere le cifre del risultato
					else
					{				
							risUnita[s]=new JLabel();
							risUnita[s].setBounds(20, 25, 110, 35);
							griglia[i][j].add(risUnita[s]);
							s++;
							
						
					}
				}
				//siamo al centro della matrice
				else
				{
					//ogni casella è divisa in 2 triangoli, ognuno contenente le unità o le decine
					//label delle decine
					up[l]=new JLabel();
					up[l].setBounds(5, 5, 60, 45);
					griglia[i][j].add(up[l]);
					
					//label delle unità
					down[l]=new JLabel();
					down[l].setBounds(70, 50, 60, 45);
					griglia[i][j].add(down[l]);
					
					//icona diagonale che compare al momento del calcolo del risultato
					slash[l]=new JLabel(icon);
					slash[l].setBounds(0, 0, 130, 100);
					slash[l].setVisible(false);
					griglia[i][j].add(slash[l]);
					l++;
					//setta il bordo della griglia
					griglia[i][j].setBorder(border);
				}
				griglia[i][j].setBounds(x, y, 130, 100);
				griglia[i][j].setOpaque(false);
				add(griglia[i][j]);
				x+=130;
			}
			y+=100;
		}
		//label n*X
		for(int i=0;i<4;i++)
		{
			int num=0;
			switch(i){
			case 0: num=1000;break;
			case 1: num=100;break;
			case 2: num=10;break;
			case 3: num=1;
			}
			//inserisce le didascalie sopra i pulsanti "+" della prima riga(es. N x 100 (10^2))
			didascalia[i]=new JLabel("N x "+num+"(10^"+(3-i)+")");
			didascalia[i].setBounds(xSpace, 10, 140, 90);
			didascalia[i].setFont(italic);
			add(didascalia[i]);
			xSpace+=130;
		}
		for(int i=4;i<7;i++)
		{
			int num=0;
			switch(i){
			case 4: num=100;break;
			case 5: num=10;break;
			case 6: num=1;
			}
			//inserisce le didascalie sopra i pulsanti "+" dell' ultima colonna(es. N x 100 (10^2))
			didascalia[i]=new JLabel("N x "+num+"(10^"+(6-i)+")");
			didascalia[i].setBounds(680, ySpace, 140, 90);
			didascalia[i].setFont(italic);
			add(didascalia[i]);
			ySpace+=100;
		}
		
		//layout del pannello che contiene le 10 cifre in verticale
		elencoNumeri.setLayout(null);
		elencoNumeri.setBounds(larghezza-((int)(larghezza/2.8)), 0, 320, 580);
		//controllo per risoluzione da 1024 x YYY in giù
		if(larghezza<=1024)
			elencoNumeri.setBackground(Color.CYAN);
		else
			elencoNumeri.setBackground(Color.WHITE);
		elencoNumeri.setVisible(false);
		
		//popola i label delle 10 cifre con le relative icone maya
		for(int i=0;i<numero.length;i++)
		{
			numero[i]=new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/"+i+".jpg")).getImage().getScaledInstance(80, 50, 0));
			numeroLabel[i]=new JLabel(numero[i]);
			numeroLabel[i].setBounds(5, n, 100, 50);
			elencoNumeri.add(numeroLabel[i]);
			
			//i bottoni di selezione della cifra
			num[i]=new JButton(""+i);
			num[i].setActionCommand("n"+i);
			num[i].setBounds(110, n+10, 80, 30);
			num[i].setBackground(Color.YELLOW);
			num[i].setFont(f);
			elencoNumeri.add(num[i]);
			
			n+=55;
		}
		add(elencoNumeri);
		
		//se la risoluzione è <= 1024 x YYY viene aggiunto un pulsante "chiudi pannello" al pannello descrizione
		if(larghezza<=1024)
		{
			chiudiDescr=new JButton("chiudi descrizione");
			chiudiDescr.setActionCommand("chiudiD");
			chiudiDescr.setBackground(Color.GRAY);
			chiudiDescr.setFont(f);
			chiudiDescr.setBounds(60, 490, 200, 30);
			descrizione.add(chiudiDescr);
			descrizione.setBackground(Color.YELLOW);
			
			for(int i=4;i<7;i++)
			{
				plus[i].setVisible(false);
				didascalia[i].setVisible(false);
			}
		}
		
		//pulsante calcola
		calcola=new JButton("Calcola");
		calcola.setBounds(470, 500, 300, 40);
		//gestione degli elementi grafici per risoluzione <=1024 x YYY
		if(larghezza<=1024)
			calcola.setVisible(false);
		calcola.setBackground(Color.GREEN);
		calcola.setFont(f);
		add(calcola);
		
		//pulsante reset
		reset=new JButton("Reset");
		reset.setBounds(200, 510, 200, 30);
		reset.setBackground(Color.GRAY);
		reset.setFont(f);
		add(reset);
		
		
		//eventi
		event e=new event();
		for(int j=0;j<plus.length;j++)
			plus[j].addActionListener(e);
		
		for(int j=0;j<num.length;j++)
			num[j].addActionListener(e);
		
		calcola.addActionListener(e);
		reset.addActionListener(e);
		if(larghezza<=1024)
			chiudiDescr.addActionListener(e);
	
	}
	public class event implements ActionListener
	{
		int buttonClicked;
		public void actionPerformed(ActionEvent e) {
			String op=e.getActionCommand();
			
			//se viene cliccato un pulsante "+"
			if(op.charAt(0)!='n' && op.length()<=2)
			{
				plus[buttonClicked].setBackground(Color.GREEN);
				elencoNumeri.setVisible(true);
				
				buttonClicked=Integer.parseInt(op);
				plus[buttonClicked].setBackground(Color.RED);
				descrizione.setVisible(false);
				
				//gestione degli elementi grafici per risoluzione <=1024 x YYY
				if(larghezza<=1024)
				{
					for(int i=4;i<7;i++)
					{
						plus[i].setVisible(false);
						didascalia[i].setVisible(false);
						label[i].setSize(0, 0);
					}
					//gestione degli elementi grafici per risoluzione <=1000 x YYY (800x600)
					if(larghezza<=1000)
					{
						griglia[1][4].setVisible(false);
						griglia[2][4].setVisible(false);
						griglia[3][4].setVisible(false);
						calcola.setVisible(false);
						
						plus[2].setVisible(false);
						plus[3].setVisible(false);
						didascalia[3].setVisible(false);
						label[3].setSize(0, 0);
					}
				}
				calcola.setVisible(false);
			}
			
			//click del pultante "calcola"
			else if(op.equals("Calcola"))
			{
				for(int l=0;l<slash.length;l++)
				{
					//conpaiono le diagonali blu
					slash[l].setVisible(true);
					
					//si passano le info di input alla matrice e dentro essa avverranno le operazioni matematiche
					matrix=new Matrice();
					matrix.inserisci(griglia,0);
					matrix.inserisci(griglia,1);
					matrix.calcola();
					//disegna i valori della matrice nell' interfaccia grafica
					paint(matrix.getMatrix());
					
					//setto a 0 tutti i valori degli operandi non selezionati
					for(int i=0;i<valueArray.length;i++)
					{
						if(valueArray[i]==0)
						{
							//gestione degli elementi grafici per risoluzione <=1024 x YYY
							if(larghezza<=1024 && i>=4)
								label[i].setSize(130, 100);
							
							label[i].setVisible(true);
							label[i].setIcon(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/0.jpg")).getImage().getScaledInstance(110, 70, 0)));
							plus[i].setVisible(false);
						}
					}
				}
				//sparisce il tasto "calcola"
				calcola.setVisible(false);
			}
			//click su tasto "reset"
			else if(op.equals("Reset"))
			{
				//chiude la finestra
				dispose();
				//setta tutti i valori dell'array statico a 0 (altrimenti rimangono i valori del calcolo precedente, essendo "statico")
				for(int i=0;i<valueArray.length;i++)
					valueArray[i]=0;
				
				//ricrea il frame
				Interface finestra=new Interface();
				finestra.setDefaultCloseOperation(EXIT_ON_CLOSE);
				finestra.setTitle("Maya");
				finestra.setVisible(true);
				finestra.setBounds(80, 50, 1200, 650);
			}
			//click sul pulsante "chiudi descrizione" (solo per risoluzioni <=1024 x YYY)
			else if(op.equals("chiudiD"))
			{
				descrizione.setVisible(false);
				calcola.setVisible(true);
				for(int i=4;i<7;i++)
				{
					plus[i].setVisible(true);
					didascalia[i].setVisible(true);
				}
				plus[2].setVisible(true);
				plus[3].setVisible(true);
			}
			//click della cifra decimale
			else
			{
				//scompare il punsante "+" per far posto all'icona del numero maya selezionato
				plus[buttonClicked].setVisible(false);
				label[buttonClicked].setIcon(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/"+Integer.parseInt(op.substring(1, 2))+".jpg")).getImage().getScaledInstance(110, 70, 0)));
				label[buttonClicked].setVisible(true);
				//il vero valore scelto viene immagazzinato sull'array valueArray
				valueArray[buttonClicked]=Integer.parseInt(""+op.charAt(1));
				
				elencoNumeri.setVisible(false);
				
				if(larghezza>1024)
					descrizione.setVisible(true);
				//gestione degli elementi grafici per risoluzione <=1024 x YYY
				else
				{
					//ultima colonna...
					for(int i=4;i<7;i++)
					{
						if(!label[i].isVisible())
							plus[i].setVisible(true);
						else
							label[i].setSize(140, 90);
						didascalia[i].setVisible(true);
					}
					//gestione degli elementi grafici per risoluzione <=1000 x YYY (800x600)
					if(larghezza<=1000)
					{
						griglia[1][4].setVisible(true);
						griglia[2][4].setVisible(true);
						griglia[3][4].setVisible(true);
						calcola.setVisible(true);
						
						didascalia[3].setVisible(true);
						
						if(!label[3].isVisible())
							plus[3].setVisible(true);
						else
							label[3].setSize(140, 90);
						if(!label[2].isVisible())
							plus[2].setVisible(true);
						else
							label[2].setSize(140, 90);
					}
				}
				calcola.setVisible(true);
			}
			
			
			
		}
	}
	//restituisce il valore i-esimo inserito (da alto a sinistra (prima riga) a basso-destra (ultima colonna))
	public static int getBoxValue(int index)
	{
		return valueArray[index];
	}
	
	//disegna i valori sul frame dopo aver effettuato i calcoli aritmetici
	private void paint(Elemento[][] matrice)
	{
		int n=0;
		for(int i=1;i<4;i++)
		{
			for(int j=1;j<5;j++)
			{
				//inserimento icona unità
				if(matrice[i][j].getValue()!=0)
					down[n].setIcon(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/"+matrice[i][j].getValue()+".jpg")).getImage().getScaledInstance(58, 37, 0)));
				//inserimento icona decine
				if(matrice[i][j].getRip()!=0)
					up[n].setIcon(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/"+matrice[i][j].getRip()+".jpg")).getImage().getScaledInstance(58, 37, 0)));
				n++;
			}
		}
		n=0;
		//inserisce le cifre del risultato sulla prima colonna
		for(int i=1;i<4;i++)
		{
			risUnita[n].setIcon(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/"+matrice[i][0].getUnita()+".jpg")).getImage().getScaledInstance(58, 37, 0)));
			n++;
		}
		//inserisce le cifre del risultato sull'ultima riga
		for(int j=1;j<5;j++)
		{
			risUnita[n].setIcon(new ImageIcon(new ImageIcon(this.getClass().getResource("/pack/img/"+matrice[4][j].getUnita()+".jpg")).getImage().getScaledInstance(58, 37, 0)));
			n++;
		}
	}
	
	//metodo eseguibile
	public static void main(String[] args)
	{
		Interface finestra=new Interface();
		finestra.setDefaultCloseOperation(EXIT_ON_CLOSE);
		finestra.setTitle("Maya");
		finestra.setVisible(true);
		finestra.setBounds(80, 50, 1200, 650);
	}
}
